# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.AlloyDbConnectionProfile do
  @moduledoc """
  Specifies required connection parameters, and the parameters required to create an AlloyDB destination cluster.

  ## Attributes

  *   `clusterId` (*type:* `String.t`, *default:* `nil`) - Required. The AlloyDB cluster ID that this connection profile is associated with.
  *   `settings` (*type:* `GoogleApi.DataMigration.V1.Model.AlloyDbSettings.t`, *default:* `nil`) - Immutable. Metadata used to create the destination AlloyDB cluster.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :clusterId => String.t() | nil,
          :settings => GoogleApi.DataMigration.V1.Model.AlloyDbSettings.t() | nil
        }

  field(:clusterId)
  field(:settings, as: GoogleApi.DataMigration.V1.Model.AlloyDbSettings)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.AlloyDbConnectionProfile do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.AlloyDbConnectionProfile.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.AlloyDbConnectionProfile do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
