# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.EntityMove do
  @moduledoc """
  Options to configure rule type EntityMove. The rule is used to move an entity to a new schema. The rule filter field can refer to one or more entities. The rule scope can be one of: Table, Column, Constraint, Index, View, Function, Stored Procedure, Materialized View, Sequence, UDT

  ## Attributes

  *   `newSchema` (*type:* `String.t`, *default:* `nil`) - Required. The new schema
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :newSchema => String.t() | nil
        }

  field(:newSchema)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.EntityMove do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.EntityMove.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.EntityMove do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
