# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.GenerateTcpProxyScriptRequest do
  @moduledoc """
  Request message for 'GenerateTcpProxyScript' request.

  ## Attributes

  *   `vmMachineType` (*type:* `String.t`, *default:* `nil`) - Required. The type of the Compute instance that will host the proxy.
  *   `vmName` (*type:* `String.t`, *default:* `nil`) - Required. The name of the Compute instance that will host the proxy.
  *   `vmSubnet` (*type:* `String.t`, *default:* `nil`) - Required. The name of the subnet the Compute instance will use for private connectivity. Must be supplied in the form of projects/{project}/regions/{region}/subnetworks/{subnetwork}. Note: the region for the subnet must match the Compute instance region.
  *   `vmZone` (*type:* `String.t`, *default:* `nil`) - Optional. The Google Cloud Platform zone to create the VM in. The fully qualified name of the zone must be specified, including the region name, for example "us-central1-b". If not specified, uses the "-b" zone of the destination Connection Profile's region.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :vmMachineType => String.t() | nil,
          :vmName => String.t() | nil,
          :vmSubnet => String.t() | nil,
          :vmZone => String.t() | nil
        }

  field(:vmMachineType)
  field(:vmName)
  field(:vmSubnet)
  field(:vmZone)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.GenerateTcpProxyScriptRequest do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.GenerateTcpProxyScriptRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.GenerateTcpProxyScriptRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
