# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.PrivateConnection do
  @moduledoc """
  The PrivateConnection resource is used to establish private connectivity with the customer's network.

  ## Attributes

  *   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The create time of the resource.
  *   `displayName` (*type:* `String.t`, *default:* `nil`) - The private connection display name.
  *   `error` (*type:* `GoogleApi.DataMigration.V1.Model.Status.t`, *default:* `nil`) - Output only. The error details in case of state FAILED.
  *   `labels` (*type:* `map()`, *default:* `nil`) - The resource labels for private connections to use to annotate any related underlying resources such as Compute Engine VMs. An object containing a list of "key": "value" pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The name of the resource.
  *   `state` (*type:* `String.t`, *default:* `nil`) - Output only. The state of the private connection.
  *   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The last update time of the resource.
  *   `vpcPeeringConfig` (*type:* `GoogleApi.DataMigration.V1.Model.VpcPeeringConfig.t`, *default:* `nil`) - VPC peering configuration.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :createTime => DateTime.t() | nil,
          :displayName => String.t() | nil,
          :error => GoogleApi.DataMigration.V1.Model.Status.t() | nil,
          :labels => map() | nil,
          :name => String.t() | nil,
          :state => String.t() | nil,
          :updateTime => DateTime.t() | nil,
          :vpcPeeringConfig => GoogleApi.DataMigration.V1.Model.VpcPeeringConfig.t() | nil
        }

  field(:createTime, as: DateTime)
  field(:displayName)
  field(:error, as: GoogleApi.DataMigration.V1.Model.Status)
  field(:labels, type: :map)
  field(:name)
  field(:state)
  field(:updateTime, as: DateTime)
  field(:vpcPeeringConfig, as: GoogleApi.DataMigration.V1.Model.VpcPeeringConfig)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.PrivateConnection do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.PrivateConnection.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.PrivateConnection do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
