# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.RulesFile do
  @moduledoc """
  Details of a single rules file.

  ## Attributes

  *   `rulesContent` (*type:* `String.t`, *default:* `nil`) - Required. The text content of the rules that needs to be converted.
  *   `rulesSourceFilename` (*type:* `String.t`, *default:* `nil`) - Required. The filename of the rules that needs to be converted. The filename is used mainly so that future logs of the import rules job contain it, and can therefore be searched by it.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :rulesContent => String.t() | nil,
          :rulesSourceFilename => String.t() | nil
        }

  field(:rulesContent)
  field(:rulesSourceFilename)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.RulesFile do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.RulesFile.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.RulesFile do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
