# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.ValueListFilter do
  @moduledoc """
  A list of values to filter by in ConditionalColumnSetValue

  ## Attributes

  *   `ignoreCase` (*type:* `boolean()`, *default:* `nil`) - Required. Whether to ignore case when filtering by values. Defaults to false
  *   `valuePresentList` (*type:* `String.t`, *default:* `nil`) - Required. Indicates whether the filter matches rows with values that are present in the list or those with values not present in it.
  *   `values` (*type:* `list(String.t)`, *default:* `nil`) - Required. The list to be used to filter by
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :ignoreCase => boolean() | nil,
          :valuePresentList => String.t() | nil,
          :values => list(String.t()) | nil
        }

  field(:ignoreCase)
  field(:valuePresentList)
  field(:values, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.ValueListFilter do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.ValueListFilter.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.ValueListFilter do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
