# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.VerifyMigrationJobRequest do
  @moduledoc """
  Request message for 'VerifyMigrationJob' request.

  ## Attributes

  *   `migrationJob` (*type:* `GoogleApi.DataMigration.V1.Model.MigrationJob.t`, *default:* `nil`) - Optional. The changed migration job parameters to verify. It will not update the migration job.
  *   `updateMask` (*type:* `String.t`, *default:* `nil`) - Optional. Field mask is used to specify the changed fields to be verified. It will not update the migration job.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :migrationJob => GoogleApi.DataMigration.V1.Model.MigrationJob.t() | nil,
          :updateMask => String.t() | nil
        }

  field(:migrationJob, as: GoogleApi.DataMigration.V1.Model.MigrationJob)
  field(:updateMask)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.VerifyMigrationJobRequest do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.VerifyMigrationJobRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.VerifyMigrationJobRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
