# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1.Model.VmCreationConfig do
  @moduledoc """
  VM creation configuration message

  ## Attributes

  *   `subnet` (*type:* `String.t`, *default:* `nil`) - The subnet name the vm needs to be created in.
  *   `vmMachineType` (*type:* `String.t`, *default:* `nil`) - Required. VM instance machine type to create.
  *   `vmZone` (*type:* `String.t`, *default:* `nil`) - The Google Cloud Platform zone to create the VM in.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :subnet => String.t() | nil,
          :vmMachineType => String.t() | nil,
          :vmZone => String.t() | nil
        }

  field(:subnet)
  field(:vmMachineType)
  field(:vmZone)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1.Model.VmCreationConfig do
  def decode(value, options) do
    GoogleApi.DataMigration.V1.Model.VmCreationConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1.Model.VmCreationConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
